package
{
	import fl.motion.AdjustColor;
	import flash.filters.ColorMatrixFilter;
	import flash.geom.Point;
	import org.flixel.*;

	public class PlayState extends FlxState
	{
		
		[Embed(source = "../assets/art__0000_brdr.png")] private var ImgBorder:Class;
		[Embed(source = "../assets/art__0001_land.png")] private var ImgLand:Class;
		[Embed(source = "../assets/art__0002_rnb.png")] private var ImgRainbow:Class;
		[Embed(source = "../assets/art__0003_bg.png")] private var ImgBg:Class;
		
		private var sprborder:FlxSprite;
		private var sprland:FlxSprite;
		private var sprrainbow:FlxSprite;
		private var sprbg:FlxSprite;
		
		private var hue:Number = 0;
		private var cmf:ColorMatrixFilter;
		private var ac:AdjustColor;
		private var pz:Point = new Point();
		
		private var goal:FlxText;
		private var goaltime:Number;
		private var goaltolerance:Number = 0.12;
		private var currenttime:Number;
		
		private var points:int = 0;
		private var pointstxt:FlxText;
		
		private var winlosetext:FlxText;
		
		override public function create():void
		{
			sprborder = new FlxSprite(0, 0, ImgBorder);
			sprland = new FlxSprite(0, 0, ImgLand);
			sprrainbow = new FlxSprite(0,0, ImgRainbow);
			sprbg = new FlxSprite(0, 0, ImgBg);
			
			
			ac = new AdjustColor();
			ac.hue = hue;
			ac.brightness = 0;
			ac.saturation = 0;
			ac.contrast = 0;
			cmf = new ColorMatrixFilter(ac.CalculateFinalFlatArray());
			
			goal = new FlxText(0, 50, FlxG.width);
			goal.setFormat(null, 20, 0xFFFFFF, "center", 0);
			
			winlosetext = new FlxText(0, FlxG.height / 2 - 50, FlxG.width);
			winlosetext.setFormat(null, 28, 0xFFFFFF, "center", 0);
			winlosetext.visible = false;
			
			pointstxt= new FlxText(0, 20, FlxG.width-20,points.toString());
			pointstxt.setFormat(null, 32, 0xFFFFFF, "right", 0);
			
			add(sprbg);
			//add(sprrainbow);
			add(sprland);
			add(sprborder);
			sprrainbow.x = FlxG.width / 2 - sprrainbow.origin.x;
			sprrainbow.y = FlxG.height / 2 - sprrainbow.origin.y;
			sprrainbow.alpha = 0.5;
			
			newGoal();
			add(goal);
			add(winlosetext);
			add(pointstxt);
			
			trace(getScaleFromTimeStr("1230"));
			
		}
		
		private function getHue():int
		{
			var n:Number;
			switch(points)
			{
				// easy
				case 0:
					n = FlxG.mouse.screenY / FlxG.height;
				break;
				case 1:
					n = FlxG.mouse.screenX / FlxG.width;
				break;
				case 2:
					n = FlxU.getDistance(new FlxPoint(FlxG.width / 2, FlxG.height / 2), FlxG.mouse.getScreenPosition()) / FlxG.width * 2; // from center
				break;
				case 3:
					n = FlxU.getDistance(new FlxPoint(0, FlxG.height), FlxG.mouse.getScreenPosition()) / 800; // from corner
				break;
				
				// mid
				case 4:
					n = FlxG.mouse.screenY / FlxG.height * 3;
				break;
				case 5:
					n = FlxG.mouse.screenX / FlxG.width * 3;
				break;
				case 6:
					n = FlxU.getDistance(new FlxPoint(FlxG.width / 2, FlxG.height / 2), FlxG.mouse.getScreenPosition()) * 3 / FlxG.width * 2; // from center
				break;
				case 7:
					n = FlxU.getDistance(new FlxPoint(0, FlxG.height), FlxG.mouse.getScreenPosition()) * 3 / 800; // from corner
				break;
				
				// hard
				case 8:
					n = FlxG.mouse.screenY / FlxG.height * 10;
				break;
				case 9:
					n = FlxG.mouse.screenX / FlxG.width * 10;
				break;
				case 10:
					n = FlxU.getDistance(new FlxPoint(FlxG.width / 2, FlxG.height / 2), FlxG.mouse.getScreenPosition()) * 10 / FlxG.width * 2; // from center
				break;
				case 11:
					n = FlxU.getDistance(new FlxPoint(0, FlxG.height), FlxG.mouse.getScreenPosition()) * 10 / 800; // from corner
				break;
			}
			currenttime = n;
			return n * 360;
		}
		private var state:int = 0;
		private var wincounter:Number = 0;
		
		override public function update():void
		{
			super.update();
			if (state == 0)
			{
				hue = getHue();
				
				sprrainbow.angle = currenttime * 360;
				
				if (FlxG.mouse.justPressed())
				{
					state = 1;
					goal.visible = false;
					winlosetext.visible = true;
					
					var t:Number = currenttime;
					while (t > 1) t -= 1;
					while (t < 0) t += 1;
					if (t < goaltime + goaltolerance && t > goaltime - goaltolerance)
					{
						//win
						winlosetext.text = "YES WE ARE WIN!";
						points++;
						pointstxt.text = points.toString();
					} else {
						//lose
						winlosetext.text = "NO! WE DIE! THAT WAS " + convertTime(getTimeFromScale(t).toString());
						//points--;
						pointstxt.text = points.toString();
					}
					if (points == 12)
					{
						FlxG.switchState(new WinState());
						return;
					}
					wincounter = 0.5;
				}
			} else if (state == 1) // veredict wait
			{
				wincounter -= FlxG.elapsed;
				if (wincounter <= 0)
				{
					state = 2;
				}
			} else if (state == 2) // new goal
			{
				newGoal();
				goal.visible = true;
				winlosetext.visible = false;
				state = 0;
			}
		}
		
		override public function draw():void 
		{
			super.draw();
			ac.hue = hue;
			cmf.matrix = ac.CalculateFinalFlatArray();
			FlxG.camera.buffer.applyFilter(FlxG.camera.buffer, FlxG.camera.buffer.rect, pz, cmf);
		}
		
		private function newGoal():void
		{
			goaltime = Math.random() * 1;
			goal.text = "Set time to " + convertTime(getTimeFromScale(goaltime).toString());
			//huetype = Math.floor(FlxG.random() * huetypes);
		}
		
		private function getTimeFromScale(Scale:Number):int
		{
			while (Scale > 1) Scale -= 1;
			while (Scale < 0) Scale += 1;
			
			var t:Number = Scale * (24 * 60);
			t /= 60;
			var hour:int = Math.floor(t);
			var mins:int = Math.floor((t - Math.floor(t)) * 60);
			
			
			var m:String = mins.toString();
			if (mins < 10) m = "0" + mins.toString();
			var h:String = hour.toString();
			if (hour < 10) h = "0" + hour.toString();
			return int(h+m);
		}
		private function getScaleFromTimeStr(S:String):Number
		{
			return getScaleFromTime(int(S.substr(0, 2)), int(S.substr(2, 4)));
		}
		private function getScaleFromTimeInt(I:int):Number
		{
			return getScaleFromTimeStr(I.toString());
		}
		private function getScaleFromTime(Hour:int, Minutes:int):Number
		{
			var m:String = Minutes.toString();
			if (Minutes < 10) m = "0" + Minutes.toString();
			var h:String = Hour.toString();
			if (Hour < 10) h = "0" + Hour.toString();
			return int(h + m) / 2400;
		}
		
		private function convertTime(_t:String):String
		{
			var _mTime:Number = parseInt(_t);
		//  trace(_mTime);
			
			var AMPM:String = "AM";
			if (_mTime > 1200)
			{
				_mTime = _mTime - 1200;
				AMPM = "PM";
			}
			
			var _digit:Number = 4;
			if (_mTime < 1000)
			{
				_digit = 3;
			}
			
			var _hr:String = _mTime.toString().substr(0, _digit - 2);
			var _mn:String = _mTime.toString().substr(-2);
			
			var _rtn:String = _hr + ":" + _mn + " " + AMPM;
		//  trace(_rtn);
			
			return _rtn;
		}
	}
}

